// Fichier I2C_Slave.h
/////////////////////////////////////////////////////////

/****************************************************************
 *                                                    			*
 * .Date de cration : 11/01/08                         		*
 * .Auteur : Guibert David                              		*       
 *           Cadic Matthieu										*
 *           Luzeau Yohan                                		*
 * .Descriptions :                                      		*
 *      - Librairie pour la gestion de l'I2C en mode esclave   	*
 *                                                      		*
 *                                                      		*
 *                                                      		*
 * .Remarques :                                         		*
 *      - Gestion des ordre reus par interruption plutt		*
 *		  que par polling								   		*
 *      - Adresse de la carte droite 0x4E          				*
 *                                                      		*
 ****************************************************************/
 
 

#define 	SLAVE_ADRESS	0x40					// Adresse I2C de la carte


#define 	TRIS_SCL 		TRISCbits.TRISC3		// Registre de direction du port SCL
#define 	TRIS_SDA 		TRISCbits.TRISC4		// Registre de direction du port SDA



// -----------------------------------------------------------------------
/* Initialise le module I2C
 * Configure les ports entre
 * Configure le module en esclave
 * Spcifie l'adresse et configure les interruptions
*/
void I2C_Init(void);




// -----------------------------------------------------------------------
/* Fonction appelle lors d'un interruption sur l'I2C
 * Le paramtre pass correspond  la valeur  envoyer en cas de transmission
 * La fonction retourne la dernire valeur lue lors de la dernire reception
*/
signed char InterruptI2C(unsigned char);
