/*****************************************************************
Maxime PASQUIER
Programme Carte Capteur
Vierzon 2009
*****************************************************************/





/*
|0 |  |1 |  |2 |  |3 |  |4 |  |5 |  |6 |  |7 |
|X |  |X |  |X |  |X |  |X |  |X |  |X |  |X |
|1 |2 |3 |4 |5 |6 |7 |8 |9 |10|11|12|13|14|15|
*/



#pragma config WDT=OFF
#pragma config OSC=HS
#pragma config LVP=OFF

#include <p18f452.h>
#include <delays.h>
#include <i2c.h>	   		//gestion de la communication I2C

#include "IO.h"
#include "I2C_Slave.h"		// Header de la bibliothque

char calcul_d ( void );

// Prototype de la routine de service d'interuptions de priorit haute
void Interrupt_High_Priority(void);					// Utilise pour l'IC

// Prototype de la routine de service d'interuptions de priorit basse
void Interrupt_Low_Priority(void);					// Utilise pour le timer


volatile unsigned char distance=0;	// Distance calcul
volatile int val=0;			// Derniere valeur lue lors de la derniere reception IC			

#define ECART 2
#define ERROR_CPT 5
#define ERROR 0x55

/***************************************************************************************/
/*******************************************************/
/****************************/
void main ( void ){
	unsigned char dist_temp;		// Stocke  la distance durant le calcul					
	char bary;			// Nombre de capteur allum
	char i;	
	int DATA[8];		// Tableau des capteurs

//	Configuration du C
	ConfigProcessor(DATA);
	I2C_Init();

	RCONbits.IPEN=1;						// Autorise les niveau de priorit sur les interuptions
	
	// Autorise les interruptions	
	INTCONbits.PEIE=1;						// Autorise les interruptions de basse priorit
	INTCONbits.GIE=1;						// Autorise les interruptions de haute priorit	

	INFO = 1;
/*///////////////////////////////////////////*/
/*/		   	  Boucle principale				/*/
/*///////////////////////////////////////////*/
	//distance = 0xF0;
	while (1){

		dist_temp = 0x00;				// On remet la distance  zro
		bary = 0;					// Idem pour le nbr de capteurs
		
		if ( !DATA0 ) {	dist_temp += 0x01 ; bary++; }	// On test les 8 capteurs
		if ( !DATA1 ) {	dist_temp += 0x02 ; bary++; }	// Et on met leur tat sur 
		if ( !DATA2 ) {	dist_temp += 0x04 ;	bary++; }	// Les 8 bits de l'octet
		if ( !DATA3 ) {	dist_temp += 0x08 ;	bary++; }	// A Envoy  la carte main
		if ( !DATA4 ) {	dist_temp += 0x10 ; bary++; }
		if ( !DATA5 ) {	dist_temp += 0x20 ;	bary++; }
		if ( !DATA6 ) {	dist_temp += 0x40 ; bary++; }
		if ( !DATA7 ) {	dist_temp += 0x80 ;	bary++; }
	

		distance = dist_temp;
		if ( bary != 0 ) {
			INFO = 1;
		}else INFO =0;

		//if ( bary < ERROR_CPT ) distance = dist_temp/bary;	// Si on a moin de X capteurs allum on renvoi la distance
	}// Fin du while(1)
}// Fin du prog
/****************************/
/*******************************************************/
/***************************************************************************************/

/*distance_temp=0x00;
bary=0;
dist_temp=0;

if ( DATA0 ) dist_temp |=  0x01;
if ( DATA1 ) dist_temp |=  0x02;
if ( DATA2 ) dist_temp |=  0x04;
if ( DATA3 ) dist_temp |=  0x08;
if ( DATA4 ) dist_temp |=  0x10;
if ( DATA5 ) dist_temp |=  0x20;
if ( DATA6 ) dist_temp |=  0x40;
if ( DATA7 ) dist_temp |=  0x80;
distance = distance_temp;*/

//----------------------------------------------------------------------------
// Vecteur d'interruptions de priorit basse (utilis pour le Timer)
#pragma code lowVector=0x18							// Vecteur d'interruption de priorit basse
void atInterruptLow(void)
{
	_asm goto Interrupt_Low_Priority _endasm		// On saute  la fonction MyHighInterrupt
}
#pragma code 										// Retour  la zone de code

//----------------------------------------------------------------------------
// Routine de service de l'interruption haute priorite
#pragma interrupt Interrupt_Low_Priority
void Interrupt_Low_Priority(void)
{
	if (PIR1bits.SSPIF){ 									// C'est le MSSP qui a lev l'interruption, c'est pour l'IC
		PIR1bits.SSPIF = 0; 								// On rautorise l'interruption		
		val=InterruptI2C((unsigned char) distance );	 	// On appelle la routine I2C pour traiter la requete				
	}	
}
	









//----------------------------------------------------------------------------
// Vecteur d'interruptions de priorit haute (utilis pour l'IC)
#pragma code highVector=0x08						// Vecteur d'interruption haut
void atInterruptHigh(void)
{
	_asm goto Interrupt_High_Priority _endasm		// On saute  la fonction MyHighInterrupt
}
#pragma code 										// Retour  la zone de code


//----------------------------------------------------------------------------
// Routine de service de l'interruption haute priorite
#pragma interrupt Interrupt_High_Priority
void Interrupt_High_Priority(void){	
	if (PIR1bits.SSPIF){ 									// C'est le MSSP qui a lev l'interruption, c'est pour l'IC
		PIR1bits.SSPIF = 0; 								// On rautorise l'interruption		
		val=InterruptI2C((unsigned char) distance);	 	// On appelle la routine I2C pour traiter la requete				
	}	
}
