#include <p18f452.h>

#ifndef __MOTEUR__
#define __MOTEUR__
	
	#define PWMG 		PORTCbits.RC2
	#define PWMD 		PORTCbits.RC1
	#define DIRD 		PORTDbits.RD0
	#define DIRG 		PORTDbits.RD1
	
	#define TRIS_PWMG	TRISCbits.TRISC2
	#define TRIS_PWMD	TRISCbits.TRISC1
	#define TRIS_DIRD	TRISDbits.TRISD0
	#define TRIS_DIRG	TRISDbits.TRISD1

/*-------------------------------------------------------------------
 *Fonction Moteur_Init()
 * Cette fonction initialise les moteurs
	- configurations des ports
	- configuration des timers
	- configuration des PWM G&D
*/
	void Moteur_Init(void);

/*-------------------------------------------------------------------
 * Fonction Moteur_CommandeD() qui fait rouler le robot
 * Envoi d'une valeur comprisse entre -1023 et +1024
	*cot=1 -> Mot droit // cot=2 -> Mot grauche
	* -1023 ->  fond en arriere 
	* 0 	-> arret du moteur
	* +1024 ->  fond en avant
*/
void Moteur_Commande(int vit, unsigned char cot);

#endif