#include <p18f452.h>
#include "robot.h"
#include "moteur.h"
#include "I2C_Master.h"
#include "IO.h"

//	Barycentre arrire
int int_I2C_AR ( void ){
	char i;
	char bary=0;
	int dist=0;
	int V;

	V = I2C_Receive(0x60);
	for ( i=0 ;	i<8 ; i++ ){		
		if ( V & (0x01<<(i)) ){ // On regarde les 8 bits de l'octet u  un..
			dist+=( BA*i - KA ); // Si on en trouve 1  1 on ajoute a dist sa valeur pondr
			bary++;				 // Et on incrmente le barycentre
		}
	}
	if (bary==0) return 0x55;			// Si aucn capteur d'allum...
	if (bary>4) return 0x55;			// Ou si trop d'allum...
	dist = dist/bary;					// On calcul le barycentre
	return (dist/bary);					// On l'envoi
}

// Calcul du barycentre
int int_I2C ( void ){
	char i;
	char bary=0;
	int dist=0;

	char Bg=0;
	char Bm=0; 
	char Bd=0; 

/*	if ( CPTG )*/ Bg = I2C_Receive(AdCPT_G);
/*	if ( CPTM )*/ Bm = I2C_Receive(AdCPT_M);
/*	if ( CPTD )*/ Bd = I2C_Receive(AdCPT_D);

	if ( Bd == 0xFF ) return 0xFF;
	if ( Bd == 0xF0 ) return 0xF0;

//	if ( Bg ) {
		for ( i=0 ;	i<8 ; i++ ){		
			if ( Bg & (0x01<<(i)) ){ // On regarde les 8 bits de l'octet u  un..
				dist+=( -BL*i -KL ); // Si on en trouve 1  1 on ajoute a dist sa valeur pondr
				bary++;				 // Et on incrmente le barycentre
			}
		}
//	}
//	if ( Bm ) {
		for ( i=0 ;	i<8 ; i++ ){		// La mme ici..
			if ( Bm & (0x01<<(7-i)) ){
				dist+=( BM*i - KM );
				bary++; 
			}
		}
//	}
	
		for ( i=0 ;	i<8 ; i++ ){		// Et ici aussi
			if ( Bd & (0x01<<(7-i)) ){
				dist+=( BL*i + KL );
				bary++; 
			}
		}
//	}

	if (bary==0) return 0x55;			// Si aucn capteur d'allum...
	if (bary>4) return 0x55;			// Ou si trop d'allum...
	dist = dist/bary;					// On calcul le barycentre
	return (dist/bary);					// On l'envoi
}

//---------------------------------------------------
// 6   7   8   9   10  11  12  13  14  15
//341 398 455 512 568 625 682 739 795 852
int calcul_V ( int x , int kv){	// Calcul la vitesse (tension) en fonction de la distance
	int calc = (  kv + (K*x) );
	if ( calc < 0 ) return 0;
	return ( calc );
}

/*
int calcul_PWM ( int v ){	// Calcul le PWM en fonction de la dictance
	int V = 800*v + kVBAT;
	int Vp= v + VBAT;
	return (V/Vp);
}*/

void envoi_Vit_Mot ( char distance ) {
//	static int VD = 0, VG = 0;

//	VD = calcul_V (  (int)distance );	// On calcul la vitesse a mettre au moteur
//	VD = calcul_PWM ( VD );				// On calcul le PWM en focntion de la vitesse		

//	VG = calcul_V ( -((int)distance));	// Bin la le mme mais pour l'autre cot
//	VG = calcul_PWM ( VG );

//	Partie test
//	Moteur_Commande(-VG ,1 );	// 1 -> Droit
//	Moteur_Commande(-VD ,2 );	// 2 -> Gauche	
/*
Moteur_Commande(VD ,1 );	// 1 -> Droit
Moteur_Commande(VG ,2 );	// 2 -> Gauche	
*/
}



